var selection = [[],[]];    

function comma(value) {
   return value.toLocaleString();
}

class Data{
  constructor(id){ 
    this.id = id; 
    this.vybrana_data = 0;   
    this.chyba = 0;
    this.spravne = 0;
    this.mesice = ["Leden","Únor","Březen","Duben","Květen","Červen"];
    this.popisky = ["Měsíc","Minimum","Průměr","Maximum"];
    this.title = "Teploty první poloviny roku 2017 v ČR";
    this.data = null;
  }

  makeData(){
    this.data = [[],[],[]];     //min,prumer,max
    let step_min = 0;
    let step_pru = 0;
    let step_max = 0;
    let minimum = random_int(130,170)/-10;
    let prumer = random_int(20,50)/-10;          
    let maximum = random_int(40,75)/10;    
    for(let i=0;i<6;i++){
      this.data[0][i] = Math.round((minimum + step_min)*10)/10;
      console.log( this.data[0][i].toLocaleString());
      step_min += random_int(20,50)/10;
      this.data[1][i] = Math.round((prumer + step_pru)*10)/10;
      step_pru += random_int(30,60)/10;
      this.data[2][i] = Math.round((maximum + step_max)*10)/10;
      step_max += random_int(35,65)/10;
    }   
  }
  
  createTable(rodic,addListener=false){
    let tabulka = document.createElement('table');
    tabulka.id = this.id;
    tabulka.classList.add("center","cap6");
    let row = tabulka.insertRow(0);  
    let cell;
    for(let i=0;i<4;i++){
      cell = document.createElement("th"); 
      cell.innerHTML = this.popisky[i];
      row.appendChild(cell);   
    }
    for(let i=1;i<7;i++){
        row = tabulka.insertRow(i);
        for(let j=0;j<=this.data.length;j++){
          if(j==0){
            cell = document.createElement("th");
            cell.innerHTML = this.mesice[i-1];
            row.appendChild(cell);  
          }else {
            cell = document.createElement("td");
            cell.innerHTML = this.data[j-1][i-1].toLocaleString();
            if(addListener == true)
              cell.addEventListener("click", function(){
                kontrola_dat(this,priklad1);
              });
            row.appendChild(cell);
          }        
        }
    }
    rodic.appendChild(tabulka); 
  }    
  
  getTitle(){
    return this.title;
  }
  
  getPopisky(index){
    return this.popisky[index];
  }
  
  getData(index){
    return this.data[index];
  }
  
  getMesice(){
    return this.mesice;
  }
  
  update_row(){
  
    let mesic = random_int(0,3);
    this.spravne = this.data[1][mesic];
    let chyba = random_int(18,28);
    if(random_int(0,1))
      chyba *=-1;
    this.data[1][mesic] = chyba;
    this.chyba = chyba;
  }
  
  delete_row(){
    let tabulka = document.getElementById(this.id);
    let number = random_int(1,tabulka.rows.length-1);
    this.vybrana_data = [];
    for(let i=0;i<3;i++){
      this.vybrana_data[i] =tabulka.children[0].children[number].children[(i+1)].innerText;
    }
    tabulka.deleteRow(number);
  }  
  
  make_button(rodic,priklad){
    let button = document.createElement('button');
    button.innerText = "Zkontrolovat";
    if(priklad == 1)
      button.addEventListener("click", function(){
                kontrola_vysledku(selection,priklad1,1);
              });
    else
      button.addEventListener("click", function(){
                kontrola_vysledku(selection,priklad2,2);
              });
              
    rodic.appendChild(button);
  }  
  
}

  


var priklad1 = new Data("tab_pr1");
priklad1.makeData();
priklad1.createTable(referat_1,true);    
//evidence chyby   
priklad1.update_row(); 
draw("pr1_graph",priklad1,0); 
priklad1.make_button(button_1,1);


var priklad2 = new Data("tab_pr2");
priklad2.makeData();
priklad2.createTable(referat_2);    
//evidence chyby   
priklad2.delete_row(); 
draw("pr2_graph",priklad2,1);   
priklad2.make_button(button_2,2);

function kontrola_vysledku(vyberGraf,dataTabulka,pr){
  if(pr==1){                     //pr1
  if(selection[0].length > 1)
    print_modal("modal","neutr","V grafu máš vybráno moc dat.");
  else if (selection[0].length ==0){ 
    print_modal("modal", "neutr", "V grafu jsi nic nevybral.");
  }else{
    //priprava dat kvuli carce
    let tmp_udaj = dataTabulka.vybrana_data.toString(); 
    dataTabulka.vybrana_data = tmp_udaj.replace(",", ".");
    if (dataTabulka.vybrana_data == dataTabulka.spravne && selection[0] == dataTabulka.chyba)
      print_modal("modal","ok");
    else
      if (dataTabulka.vybrana_data == dataTabulka.spravne)
        print_modal("modal", "neutr", "V tabulce jsi to vybral správně, podívej se ještě na graf.");
      else if (selection[0] == dataTabulka.chyba)
        print_modal("modal", "neutr", "V grafu jsi to vybral správně, podívej se ještě na tabulku.");
      else
        print_modal("modal","chyba");
    }  
  }else{                         //pr2
    if(selection[1].length < 3)     
      print_modal("modal","neutr","V grafu máš vybráno málo dat.");
    else if (selection[1].length > 3) 
      print_modal("modal","neutr","V grafu máš vybráno moc dat.");
    else{
      let tmp_pole = ["","",""];
      for(let x=0;x<3;x++){
        tmp_pole[x] = dataTabulka.vybrana_data[x].toString(); 
        tmp_pole[x] = tmp_pole[x].replace(",", ".");
      } 
      if(selection[1].indexOf(tmp_pole[0]) != -1 &&
         selection[1].indexOf(tmp_pole[1]) != -1 &&
         selection[1].indexOf(tmp_pole[2]) != -1)
            print_modal("modal","ok");
      else
        print_modal("modal","chyba"); 
    }  
  }
}
                                            
function kontrola_dat(bunka,data){
  if(data.vybrana_data != bunka.innerText){
    data.vybrana_data = bunka.innerText; 
    if(document.getElementById("vybrano")){        
      document.getElementById("vybrano").removeAttribute("style");
      document.getElementById("vybrano").removeAttribute("id");    
    }     
    bunka.setAttribute("id","vybrano");    
    document.getElementById("vybrano").style.backgroundColor = "rgba(0, 255, 0, 0.55)";
  }
}

//sekce grafu

Chart.helpers.merge(Chart.defaults.global, {
			aspectRatio: 4/3,
			tooltips: false,
			layout: {
				padding: {
					top: 42,
					right: 16,
					bottom: 32,
					left: 8
				}
			},
			elements: {
				line: {
					fill: false
				}
			},
			plugins: {
				legend: false,
				title: false
			}
		});

function isSelected(context,pr) {
	return lookup(context,pr) !== -1;
}
  
function lookup(context,pr) {  
  let index = context.dataIndex;
  let value = context.dataset.data[index];
  let i, ilen;

  for (i = 0, ilen = selection[pr].length; i < ilen; ++i) {
    if (selection[pr][i] == value) {
      return i;
    }
  }
  return -1;
}

function select(context,pr) {
  var index = context.dataIndex;
  var value = context.dataset.data[index];
  
  selection[pr].push(value.toString());
  
  //alert(selection);
}

function deselect(context,pr) {
  var index = lookup(context,pr);
  if (index !== -1) {
    selection[pr].splice(index, 1);
  //alert(selection);
  }
}
  
  function draw(rodic,data,pr){
  var ctx = document.getElementById(rodic).getContext('2d'); 
      var config = {
			type: 'line',
      animating: false,
			data: {
				labels: data.getMesice(),   //getMesice    
				datasets: [{
					backgroundColor: window.chartColors.blue,
					borderColor: window.chartColors.blue,
					data: data.getData(0),
					fill: false,
          label: data.getPopisky(1),
          lineTension: 0
				}, {
					backgroundColor: window.chartColors.green,
					borderColor: window.chartColors.green,
					data: data.getData(1),
          fill: false,
          label: data.getPopisky(2), 
          lineTension: 0
				}, {
					backgroundColor: window.chartColors.red,
					borderColor: window.chartColors.red,
					data: data.getData(2),
          fill: false,
          label: data.getPopisky(3), 
          lineTension: 0
				}]
			},
			options: {
				responsive: false,
        plugins: {
					datalabels: {
                        formatter: function(value) {
                          return comma(value);
                        },
						backgroundColor: function(context) {
							return isSelected(context,pr)
								? context.dataset.backgroundColor
								: 'white';
						},
						borderColor: function(context) {
							return context.dataset.backgroundColor;
						},
						borderWidth: 1,
						color: function(context) {
							return isSelected(context,pr)
								? 'white'
								: context.dataset.backgroundColor;
						},
						font: {
							weight: 'bold'
						},
						offset: 8,
						padding: 4,
						listeners: {
							click: function(context) {
								if (isSelected(context,pr)) {
									deselect(context,pr);
								} else {
									select(context,pr);
								}

								return true;
							}
						}
					}
				}, 
        tooltips: { enabled: false},
        legend: { 
          position: "bottom",
          onClick: function (e) { e.stopPropagation(); }
        },
				title: {
					display: true,
          fontSize: 18,
					text: data.getTitle(),
				},
				layout: {
            padding: {
                left: 70,
                right: 70
            }
        }
			}
		};          
			window.myLine = new Chart(ctx, config);  
  }      